diff --git a/sys/sys/caprevoke.h b/sys/sys/caprevoke.h
new file mode 100644
index 000000000000..5d97a4a2776a
--- /dev/null
+++ b/sys/sys/caprevoke.h
@@ -0,0 +1,342 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2018 SRI International
+ * All rights reserved.
+ *
+ * This software was developed by SRI International and the University of
+ * Cambridge Computer Laboratory under DARPA/AFRL contract FA8750-10-C-0237
+ * ("CTSRD"), as part of the DARPA CRASH research programme.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef __SYS_CAPREVOKE_H__
+#define	__SYS_CAPREVOKE_H__
+
+/*
+ * The outermost capability revocation state machine.
+ *
+ *   We begin with no revocation in progress (CAPREVST_NONE).  Userland can
+ *   request that we steal the calling thread to carry out an initial pass,
+ *   which will begin the next epoch and visit all cap-dirty pages in the
+ *   address space, moving us to CAPREVST_INIT_PASS for the duration and to
+ *   CAPREVST_INIT_DONE upon completion, before returning to userland.
+ *
+ *   We are now in the store-side steady state for this epoch: we need only
+ *   look at *recently* capdirty pages, kernel hoarders, and register files
+ *   to find should-be-revoked pages.  Userland can request additional
+ *   passes, which will be *incremental* passes, visiting only capdirty
+ *   pages (and keeping us in CAPREVST_STORE_DONE).
+ *
+ *   Alternatively, userland can request that we finish this epoch,
+ *   transitioning us into CAPREVST_LAST_PASS for the duration.  This pass
+ *   visits all recently capdirty pages, kernel hoarders, and thread
+ *   register files.  It implies at least some brief window of
+ *   thread_single'd life.  When this pass finishes, it again increments
+ *   the epoch counter, signaling the end of this epoch.
+ *
+ *     XXX The thread_single window can be reduced by using the "load-side"
+ *     strategy, in which we temporarily remove read access to all
+ *     recently-capdirty pages and then un-thread_single.  We would continue
+ *     to use the calling thread to sweep pages "in the background", but would
+ *     also clean pages when taking vm faults.  The epoch must not end
+ *     before all pages have been cleaned!
+ *
+ *   Userland might cause us to jump directly from CAPREVST_NONE to
+ *   CAPREVST_LAST_PASS.  This case is *almost* like the above, except that
+ *   we have to consider *all* capdirty pages, not just recently-capdirty.
+ *
+ * The state and epoch counter are stored in the same per-process word,
+ * vm_caprev_st.  There is, at present, at most one thread actively engaged
+ * in revocation per process.
+ */
+
+enum caprevoke_state {
+	CAPREVST_NONE      = 0,	/* No revocation is in progress */
+	CAPREVST_INIT_PASS = 1,	/* Currently executing a "store-side" pass */
+	CAPREVST_INIT_DONE = 2,	/* > 0 store-sides done, no pass running */
+	CAPREVST_LAST_PASS = 3,	/* Last, "load-side"/STW pass running */
+};
+
+#define CAPREVST_ST_MASK	0x3
+#define CAPREVST_EPOCH_SHIFT	2
+#define CAPREVST_EPOCH_WIDTH	62
+
+typedef uint64_t caprevoke_epoch;
+
+/*
+ * Epoch greater than orderings: a > b, a >= b.
+ *
+ * We use RFC1982 serial number arithmetic to deal with wrap-around.  We
+ * assume that there will never be any reason to ask about epochs so far
+ * apart that this is problematic.
+ *
+ * We could probably get away without wraparound handling, given the current
+ * value of CAPREVST_EPOCH_WIDTH, but on the chance that it becomes
+ * significantly shorter, it doesn't hurt to have this abstracted.
+ *
+ * XXX this almost surely belongs somewhere else.
+ */
+
+static inline int caprevoke_epoch_gt(caprevoke_epoch a, caprevoke_epoch b) {
+	return ((a < b) && ((b - a) > (1ULL << (CAPREVST_EPOCH_WIDTH-1))))
+	    || ((a > b) && ((a - b) < (1ULL << (CAPREVST_EPOCH_WIDTH-1))));
+}
+static inline int caprevoke_epoch_ge(caprevoke_epoch a, caprevoke_epoch b) {
+	return (a == b) || caprevoke_epoch_gt(a, b);
+}
+
+static inline int caprevoke_epoch_clears(caprevoke_epoch now,
+                                         caprevoke_epoch then) {
+	return caprevoke_epoch_ge(now, then + (then & 1) + 2);
+}
+
+	/*
+	 * Finish the current revocation epoch this pass.
+	 * If there is no current revocation epoch, start one and then
+	 * finish it.
+	 *
+	 * If this flag is not given, then either start an epoch by doing
+	 * the first (full) pass or continue an epoch by doing an
+	 * incremental pass.
+	 */
+#define CAPREVOKE_LAST_PASS	0x001
+
+	/*
+	 * If this bit is set, the kernel is free to return without making
+	 * progress.
+	 *
+	 * The returned statistics describe any transitions that take place
+	 * as a result of this request, but not any that result due to
+	 * backgrounded work.
+	 *
+	 * If set without CAPREVOKE_IGNORE_START, the kernel may treat this
+	 * as a hint that background revocation may be useful (XXX but we
+	 * don't implement that yet).
+	 *
+	 */
+#define	CAPREVOKE_NO_WAIT_OK	0x002
+
+	/*
+	 * Ignore the given epoch argument and always attempt to advance the
+	 * epoch clock relative to its value "at the time of the call".
+	 */
+#define CAPREVOKE_IGNORE_START	0x004
+
+	/*
+	 * Do a pass only if an epoch is open after synchronization.  This
+	 * is most useful when we want to get to the end of an epoch as
+	 * quickly as possible; if we're already past the end, then we
+	 * should just stay there.
+	 */
+#define CAPREVOKE_ONLY_IF_OPEN	0x008
+
+	/*
+	 * Ordinarily, caprevoke with CAPREVOKE_LAST_PASS attempts to
+	 * minimize the amount of work it does with the world held in
+	 * single-threaded state.  It will do up to three passes:
+	 *
+	 *   * an opening/incremental pass with the world running
+	 *
+	 *   * a pass with the world stopped, which visits kernel hoarders
+	 *     and recently-dirty pages (since the above pass)
+	 *
+	 *   * another pass with the world resumed, again visiting
+	 *     recently-dirty pages.  (XXX Not yet!)
+	 *
+	 * The first and/or last of these may be disabled by passing
+	 * CAPREVOKE_LAST_NO_EARLY and/or CAPREVOKE_LAST_NO_LATE flags,
+	 * causing more work to be pushed into the world-stopped phase.
+	 *
+	 * Setting CAPREVOKE_LAST_NO_EARLY when not setting
+	 * CAPREVOKE_LAST_PASS will cause no passes to be performed.
+	 *
+	 * XXX CAPREVOKE_LAST_NO_LATE is currently implied because our VM
+	 * does not actually take advantage of the split.  This is
+	 * post-ASPLOS work at the earliest.
+	 */
+#define CAPREVOKE_LAST_NO_EARLY	0x010
+#define CAPREVOKE_LAST_NO_LATE	0x020
+
+	/*
+	 * Force a synchronization with the PMAP before doing a non-LAST
+	 * pass (including the EARLY part of a LAST call).  This should let
+	 * us measure the impact of lazily synchronizing with the PMAP
+	 * capdirty bits.
+	 *
+	 * This may also be useful if one were to do intermediate (i.e.,
+	 * neither opening nor closing) passes, but at present we do not.
+	 *
+	 * Meaningless if CAPREVOKE_LAST_NO_EARLY also set.
+	 */
+#define CAPREVOKE_EARLY_SYNC	0x040
+
+	/*
+	 * Some flags indicate that we are to engage in a blocking
+	 * capability revocation sweep on a subset of the entire address
+	 * space.  If any of these are set, we bypass the above state
+	 * machine and visit only the indicated locations.  This is an
+	 * expermental feature to see if this kind of mitigation, while
+	 * unsound, is still a useful thing to do.
+	 *
+	 */
+/* CAPREVOKE_JUST_THE_TIME was 0x100; it is removed for being unsafe */
+#define CAPREVOKE_JUST_MY_REGS  0x200	/* Calling thread register file */
+#define CAPREVOKE_JUST_MY_STACK	0x400	/* Calling thread stack */
+#define CAPREVOKE_JUST_HOARDERS 0x800	/* Kernel hoarders */
+#define CAPREVOKE_JUST_MASK	0xF00
+
+	/*
+	 * XXX In a colocated proc model, just the current proc?  Is this a
+	 * thing we want?  If so, how do we make it fit with our story?
+	 * Does it not alter the epoch clock?  Is there a second clock?
+	 */
+// #define CAPREVOKE_COLO_JUST_ME		0x1000
+
+/*
+ * Information conveyed to userland about a given caprevoke scan.
+ */
+struct caprevoke_stats {
+
+		/*
+		 * The synchronized time at the start of the call.  This
+		 * value is useful for *enqueueing* objects to quarantine:
+		 * all bitmap writes prior to the system call certainly
+		 * happened in or before epoch_init, and so waiting for the
+		 * epoch to advance sufficiently far relative to epoch_init
+		 * will ensure that those objects have been revoked.
+		 */
+	caprevoke_epoch	epoch_init;
+
+		/*
+		 * The synchronized time at the end of the call.  This value
+		 * is useful for *dequeueing* objects from quarantine: if
+		 * this value clears the recorded epoch_init, then those
+		 * objects have been revoked.
+		 *
+		 * It may be the case that epoch_fini < epoch_init.  This
+		 * implies that an epoch transition is in progress but that
+		 * the requested "start_epoch" given to caprevoke() has been
+		 * cleared by the reported value of epoch_fini, and so there
+		 * is no reason to wait for the transition to finish.
+		 */
+	caprevoke_epoch	epoch_fini;
+
+		/*
+		 * The remainder of the fields of this structure are purely
+		 * informative; they may be of slight interest to policies,
+		 * but shouldn't influence correctness.
+		 */
+
+	uint64_t	page_scan_cycles;
+
+	uint32_t	pages_retried;
+	uint32_t	pages_scan_ro;
+	uint32_t	pages_scan_rw;
+
+	uint32_t	pages_faulted_ro;
+	uint32_t	pages_faulted_rw;
+
+	uint32_t	pages_skip_fast;
+	uint32_t	pages_skip;
+
+	uint32_t	caps_found;
+	uint32_t	caps_found_revoked;
+
+	uint32_t	caps_cleared;
+
+	uint32_t	lines_scan;
+	uint32_t	pages_mark_clean;
+
+	uint32_t	__spare[2];
+};
+
+struct caprevoke_info {
+	caprevoke_epoch epoch_enqueue;	/* Label on entry to quarantine */
+	caprevoke_epoch epoch_dequeue;	/* Gates removal from quarantine */
+};
+
+/* Returns 1 if cap is revoked, 0 otherwise. */
+static inline int caprevoke_is_revoked(void * __capability cap) {
+	return (__builtin_cheri_perms_get(cap) == 0);
+}
+
+#ifdef _KERNEL
+struct caprevoke_info_page {
+		/* Userland will come to hold RO caps to this bit */
+	struct caprevoke_info pub;
+
+		/*
+		 * The kernel is free to use the rest of this page for
+		 * private data that is quite naturally associated with
+		 * this VM space.
+		 */
+};
+#endif
+
+#define	CAPREVOKE_SHADOW_NOVMMAP	0x00	/* The ordinary shadow space */
+#define CAPREVOKE_SHADOW_OTYPE		0x01	/* The otype shadow space */
+/*
+ * It is not possible to ask for the _MEM_MAP bitmask, as we intend that one
+ * to be used by the kernel internally for munmap().  Maybe that's wrong?
+ *
+ * XXX Do we want a madvise mode to allow userspace to request revocation
+ * of vm objects that we aren't deleting?  They *can* use the NOVMMAP
+ * bitmask, but it's 256 times as many bits to flip.
+ */
+#define CAPREVOKE_SHADOW_INFO_STRUCT	0x03	/* R/O access to shared state */
+#define CAPREVOKE_SHADOW_SPACE_MASK	0x03	/* Flag bits for shadow index */
+
+#ifndef _KERNEL
+
+	/*
+	 * Drive the revocation state machine.
+	 *
+	 * If the current epoch clock is sufficient to caprvoke_epoch_clears
+	 * start_epoch, this call returns immediately, populating
+	 * statout->epoch_{init,fini} with the current clock's value.
+	 *
+	 * XXX if caprevoke_epoch becomes more complex than a scalar type,
+	 * this prototype will need to change or we'll need to be more
+	 * explicit about it being a hint or something.
+	 */
+int caprevoke(int flags, caprevoke_epoch start_epoch,
+		struct caprevoke_stats *statout);
+
+	/*
+	 * Request a capability to the shadow bitmap state for the given
+	 * arena.  Flags determine which space is requested; the arena cap
+	 * must have appropriate privileges.
+	 *
+	 * This call must fail if the resulting capability would not be
+	 * representable due to alignment constraints.
+	 */
+int caprevoke_shadow(int flags,
+	void * __capability arena,
+	void * __capability * shadow);
+
+/* Set *shadow to a capability granting access to the entire shadow space. */
+int caprevoke_entire_shadow_cap(void * __capability *shadow);
+#endif
+
+#endif /* !__SYS_CAPREVOKE_H__ */
diff --git a/sys/sys/mman.h b/sys/sys/mman.h
index ccda37212bfa..e0a4051e02c5 100644
--- a/sys/sys/mman.h
+++ b/sys/sys/mman.h
@@ -197,14 +197,18 @@
 #define	MINCORE_REFERENCED_OTHER 0x8 /* Page has been referenced */
 #define	MINCORE_MODIFIED_OTHER	0x10 /* Page has been modified */
 #define	MINCORE_SUPER		0x20 /* Page is a "super" page */
+#if __has_feature(capabilities)
+#define MINCORE_MAYHAVECAP	0x40 /* Page may contain capabilities */
+#endif
 
 /*
  * Anonymous object constant for shm_open().
  */
-#ifndef _KERNEL
-#define	SHM_ANON		((char *)1)
+#if __has_feature(capabilities) && \
+	(defined(_KERNEL) || defined(__CHERI_PURE_CAPABILITY__))
+#define	SHM_ANON		((char * __capability)(__intcap_t)1)
 #else
-#define	SHM_ANON		((char * __capability)(intcap_t)1)
+#define	SHM_ANON		((char *)(__intptr_t)1)
 #endif
 
 /*
diff --git a/sys/sys/sysargmap.h b/sys/sys/sysargmap.h
index d61904d2140f..cc1acce54da7 100644
--- a/sys/sys/sysargmap.h
+++ b/sys/sys/sysargmap.h
@@ -165,6 +165,9 @@ static int sysargmask[] = {
 	[SYS_aio_write] = (0x0 | 0x1),
 	[SYS_lio_listio] = (0x0 | 0x2 | 0x8),
 	[SYS_kbounce] = (0x0 | 0x1 | 0x2),
+	[SYS_caprevoke_shadow] = (0x0 | 0x2 | 0x4),
+	[SYS_caprevoke] = (0x0 | 0x4),
+	[SYS_caprevoke_entire_shadow_cap] = (0x0 | 0x1),
 	[SYS_lchmod] = (0x0 | 0x1),
 	[SYS_lutimes] = (0x0 | 0x1 | 0x2),
 	[SYS_preadv] = (0x0 | 0x2),
diff --git a/sys/sys/syscall.h b/sys/sys/syscall.h
index d7586a9cb404..d1143af9ddda 100644
--- a/sys/sys/syscall.h
+++ b/sys/sys/syscall.h
@@ -235,6 +235,9 @@
 #define	SYS_aio_write	256
 #define	SYS_lio_listio	257
 #define	SYS_kbounce	258
+#define	SYS_caprevoke_shadow	259
+#define	SYS_caprevoke	260
+#define	SYS_caprevoke_entire_shadow_cap	261
 #define	SYS_freebsd11_getdents	272
 #define	SYS_lchmod	274
 				/* 275 is obsolete netbsd_lchown */
diff --git a/sys/sys/syscall.mk b/sys/sys/syscall.mk
index 577f1724dc70..94c706c5cc0c 100644
--- a/sys/sys/syscall.mk
+++ b/sys/sys/syscall.mk
@@ -169,6 +169,9 @@ MIASM =  \
 	aio_write.o \
 	lio_listio.o \
 	kbounce.o \
+	caprevoke_shadow.o \
+	caprevoke.o \
+	caprevoke_entire_shadow_cap.o \
 	freebsd11_getdents.o \
 	lchmod.o \
 	lutimes.o \
diff --git a/sys/sys/sysproto.h b/sys/sys/sysproto.h
index e717ec4145a4..cc9a8be8da18 100644
--- a/sys/sys/sysproto.h
+++ b/sys/sys/sysproto.h
@@ -729,6 +729,19 @@ struct kbounce_args {
 	char len_l_[PADL_(size_t)]; size_t len; char len_r_[PADR_(size_t)];
 	char flags_l_[PADL_(int)]; int flags; char flags_r_[PADR_(int)];
 };
+struct caprevoke_shadow_args {
+	char flags_l_[PADL_(int)]; int flags; char flags_r_[PADR_(int)];
+	char arena_l_[PADL_(void * __capability)]; void * __capability arena; char arena_r_[PADR_(void * __capability)];
+	char shadow_l_[PADL_(void * __capability)]; void * __capability shadow; char shadow_r_[PADR_(void * __capability)];
+};
+struct caprevoke_args {
+	char flags_l_[PADL_(int)]; int flags; char flags_r_[PADR_(int)];
+	char start_epoch_l_[PADL_(uint64_t)]; uint64_t start_epoch; char start_epoch_r_[PADR_(uint64_t)];
+	char statout_l_[PADL_(struct caprevoke_stats * __capability)]; struct caprevoke_stats * __capability statout; char statout_r_[PADR_(struct caprevoke_stats * __capability)];
+};
+struct caprevoke_entire_shadow_cap_args {
+	char shadow_l_[PADL_(void * __capability)]; void * __capability shadow; char shadow_r_[PADR_(void * __capability)];
+};
 struct lchmod_args {
 	char path_l_[PADL_(const char * __capability)]; const char * __capability path; char path_r_[PADR_(const char * __capability)];
 	char mode_l_[PADL_(mode_t)]; mode_t mode; char mode_r_[PADR_(mode_t)];
@@ -1990,6 +2003,9 @@ int	sys_aio_read(struct thread *, struct aio_read_args *);
 int	sys_aio_write(struct thread *, struct aio_write_args *);
 int	sys_lio_listio(struct thread *, struct lio_listio_args *);
 int	sys_kbounce(struct thread *, struct kbounce_args *);
+int	sys_caprevoke_shadow(struct thread *, struct caprevoke_shadow_args *);
+int	sys_caprevoke(struct thread *, struct caprevoke_args *);
+int	sys_caprevoke_entire_shadow_cap(struct thread *, struct caprevoke_entire_shadow_cap_args *);
 int	sys_lchmod(struct thread *, struct lchmod_args *);
 int	sys_lutimes(struct thread *, struct lutimes_args *);
 int	sys_preadv(struct thread *, struct preadv_args *);
@@ -2894,6 +2910,9 @@ int	freebsd12_shm_open(struct thread *, struct freebsd12_shm_open_args *);
 #define	SYS_AUE_aio_write	AUE_AIO_WRITE
 #define	SYS_AUE_lio_listio	AUE_LIO_LISTIO
 #define	SYS_AUE_kbounce	AUE_NULL
+#define	SYS_AUE_caprevoke_shadow	AUE_NULL
+#define	SYS_AUE_caprevoke	AUE_NULL
+#define	SYS_AUE_caprevoke_entire_shadow_cap	AUE_NULL
 #define	SYS_AUE_freebsd11_getdents	AUE_O_GETDENTS
 #define	SYS_AUE_lchmod	AUE_LCHMOD
 #define	SYS_AUE_lutimes	AUE_LUTIMES
diff --git a/sys/sys/user.h b/sys/sys/user.h
index b9b71b381e36..a1324d8f9962 100644
--- a/sys/sys/user.h
+++ b/sys/sys/user.h
@@ -464,6 +464,8 @@ struct kinfo_file {
 #define	KVME_PROT_READ		0x00000001
 #define	KVME_PROT_WRITE		0x00000002
 #define	KVME_PROT_EXEC		0x00000004
+#define	KVME_PROT_READCAPS	0x00000100
+#define	KVME_PROT_WRITECAPS	0x00000200
 
 #define	KVME_FLAG_COW		0x00000001
 #define	KVME_FLAG_NEEDS_COPY	0x00000002
@@ -524,7 +526,8 @@ struct kinfo_vmentry {
 	uint16_t kve_status;			/* Status flags. */
 	uint64_t kve_vn_fsid;			/* dev_t of vnode location */
 	uint64_t kve_vn_rdev;			/* Device id if device. */
-	int	 _kve_ispare[8];		/* Space for more stuff. */
+	int      kve_max_protection;		/* Maximum protection bitmask */
+	int	 _kve_ispare[7];		/* Space for more stuff. */
 	/* Truncated before copyout in sysctl */
 	char	 kve_path[PATH_MAX];		/* Path to VM obj, if any. */
 };
@@ -606,7 +609,7 @@ int	kern_proc_filedesc_out(struct proc *p, struct sbuf *sb, ssize_t maxlen,
 int	kern_proc_cwd_out(struct proc *p, struct sbuf *sb, ssize_t maxlen);
 int	kern_proc_out(struct proc *p, struct sbuf *sb, int flags);
 int	kern_proc_vmmap_out(struct proc *p, struct sbuf *sb, ssize_t maxlen,
-	int flags);
+	vm_offset_t startaddr, size_t max, int flags);
 
 int	vntype_to_kinfo(int vtype);
 void	pack_kinfo(struct kinfo_file *kif);
diff --git a/sys/vm/pmap.h b/sys/vm/pmap.h
index 04d54ece852a..b89202608d1b 100644
--- a/sys/vm/pmap.h
+++ b/sys/vm/pmap.h
@@ -174,6 +174,10 @@ void		 pmap_remove_all(vm_page_t m);
 void		 pmap_remove_pages(pmap_t);
 void		 pmap_remove_write(vm_page_t m);
 void		 pmap_sync_icache(pmap_t, vm_offset_t, vm_size_t);
+#if __has_feature(capabilities)
+boolean_t	 pmap_tc_capdirty(vm_page_t m);
+void		 pmap_sync_capdirty(pmap_t);
+#endif
 int		 pmap_ts_referenced(vm_page_t m);
 void		 pmap_unwire(pmap_t pmap, vm_offset_t start, vm_offset_t end);
 void		 pmap_zero_page(vm_page_t);
diff --git a/sys/vm/swap_pager.c b/sys/vm/swap_pager.c
index a6c2e104ccd5..72e6426ade63 100644
--- a/sys/vm/swap_pager.c
+++ b/sys/vm/swap_pager.c
@@ -2187,6 +2187,7 @@ swp_pager_meta_cheri_get_tags(vm_page_t page)
 	void * __capability *p;
 	struct swblk *sb;
 	vm_pindex_t swidx;
+	int mark_capdirty = 0;
 
 	swidx = rounddown(page->pindex, SWAP_META_PAGES);
 	scan = (void *)PHYS_TO_DMAP(VM_PAGE_TO_PHYS(page));
@@ -2196,18 +2197,33 @@ swp_pager_meta_cheri_get_tags(vm_page_t page)
 	    i < (swidx + 1) * BITS_PER_TAGS_PER_PAGE; i++) {
 		p = scan;
 		for (t = sb->swb_tags[i]; t != 0; t >>= j) {
+			mark_capdirty = 1;
 			j = ffsl((long)t);
 			cheri_restore_tag(p + j - 1);
 			p += j;
 		}
 		scan += 8 * sizeof(uint64_t);
 	}
+
+	/*
+	 * Because we stored through the direct region we will have bypassed
+	 * the TLB and all implicit capdirty tracking.  If we stored a
+	 * capability, mark the page as recently dirtied.
+	 *
+	 * This has to be recent (PGA_CAPSTORED) and not just dirty
+	 * (VPO_PASTCAPSTORE) so that incremental scans of the address space
+	 * still consider it.
+	 */
+	if (mark_capdirty)
+		vm_page_aflag_set(page, PGA_CAPSTORED);
 }
 
 /*
  *	swp_pager_meta_cheri_put_tags:
  *
  *	Save the capability tags of a page to its swap metadata structure.
+ *
+ *	XXX Make this use CLoadTags eventually
  */
 static void
 swp_pager_meta_cheri_put_tags(vm_page_t page)
